'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var litHtml = require('lit-html');

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var connect = function connect() {
  var mapStateToProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var mapDispatchToProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var mergeProps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
  return function (component) {
    return function (ownProps) {
      var _storeKey$options = _extends({
        storeKey: 'store'
      }, options),
          storeKey = _storeKey$options.storeKey;

      var store = ownProps[storeKey];
      var update = function update(state) {
        var stateProps = mapStateToProps ? mapStateToProps(state, ownProps) : null;
        var dispatchProps = mapDispatchToProps ? mapDispatchToProps(store.dispatch, ownProps) : null;
        return component(mergeProps ? mergeProps(stateProps, dispatchProps, ownProps) : _extends({}, stateProps, dispatchProps, ownProps));
      };
      return litHtml.directive(function (part) {
        store.subscribe(function () {
          return part.setValue(update(store.getState()));
        });
        return update(store.getState());
      });
    };
  };
};

exports.connect = connect;
